package parkup.controllers;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import parkup.entities.RegistriranParkirac;
import parkup.services.RegistriranParkiracService;

@RestController
public class RegistriranParkiracController {
    private final RegistriranParkiracService registriranParkiracService;

    @Autowired
    public RegistriranParkiracController(RegistriranParkiracService registriranParkiracService) {
        this.registriranParkiracService = registriranParkiracService;
    }

    @GetMapping({"/registriranParkirac"})
    public List<RegistriranParkirac> getAllRegistriraniParkiraci() {
        return this.registriranParkiracService.getRegPark();
    }

    @GetMapping({"/registriranParkirac/{regParkId}"})
    public RegistriranParkirac getRegistriranParkirac(@PathVariable int regParkId) {
        RegistriranParkirac regPark = this.registriranParkiracService.findById(regParkId);
        if (regPark != null) {
            return regPark;
        } else {
            throw new RuntimeException("User not found");
        }
    }

    @PostMapping({"/registriranParkirac"})
    public void addRegistriranParkirac(@RequestBody RegistriranParkirac regPark) {
        this.registriranParkiracService.addRegPark(regPark);
    }

    @PutMapping({"/registriranParkirac/{regParkId}"})
    public void updateRegistriranParkirac(@PathVariable int regParkId, @RequestBody RegistriranParkirac regPark) {
        this.registriranParkiracService.updateRegPark(regParkId, regPark.getName(), regPark.getSurname(), regPark.getMobile(), regPark.getEmail());
    }

    @DeleteMapping({"/registriranParkirac/{regParkId}"})
    public void deleteRegistriranParkirac(@PathVariable int regParkId) {
        this.registriranParkiracService.deleteRegPark(regParkId);
    }
}